/*-
 * Copyright (c) 2002 Doug White
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 * 
 */

#ifndef KCS_H
#define KCS_H

/* KCS I/O ports */

#define KCS_BASE_IOPORT	0xCA2
#define KCS_DATAIN_IOPORT 	(KCS_BASE_IOPORT)
#define KCS_DATAOUT_IOPORT 	(KCS_BASE_IOPORT)
#define KCS_STATUS_IOPORT	(KCS_BASE_IOPORT+1)
#define KCS_CMD_IOPORT		(KCS_BASE_IOPORT+1)

/* Status register flags */

#define KCS_S1 		0x80
#define KCS_S0 		0x40
#define KCS_STATBITS    (KCS_S0 | KCS_S1)
#define KCS_OEM2	0x20
#define KCS_OEM1	0x10
#define KCS_CD		0x08 /* last-written (command or data) */
#define KCS_SMS_ATN	0x04
#define	KCS_IBF		0x02
#define	KCS_OBF		0x01

/* Status bits */

#define KCS_IDLE	0x0
#define KCS_READ	(KCS_S0)
#define KCS_WRITE	(KCS_S1)
#define	KCS_ERROR	(KCS_S0 & KCS_S1)

/* Commands */

#define KCS_CMD_GET_STATUS	0x60
#define KCS_CMD_ABORT		0x60
#define KCS_CMD_WRITE_START	0x61
#define KCS_CMD_WRITE_END	0x62
#define KCS_CMD_READ		0x68

/* Other config */

#define KCS_SLEEP_USECS	1	

#endif /* KCS_H */

