#!/usr/local/bin/python2.1
#
# Copyright (c) 2002 Doug White
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the distribution.
#
# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
# SUCH DAMAGE.
#
# $Id: ipmiping.py,v 1.2 2002/05/14 23:07:03 dwhite Exp $


import sys
import os
from socket import *

def pbyte(x):
    return "0x%x" % ord(x)

def ipmi_ping(host):
    s = socket(AF_INET, SOCK_DGRAM)
    gsn = s.getsockname()
    s.bind(gsn)
    print s.getsockname()
    destination_port = 0x26f
    # version, reserved, seq#, class
    rcmp_header = [0x06, 0x00, 0xff, 0x06]
    # asf msg: 4b enterprise, msg type, msg tag, reserved, len
    asf_enterprise = [0xbe, 0x11, 0x00, 0x00]
    asf_msg = [0x80, 0x00, 0x00, 0x00]

    # build the whole paypload
    msg = ""
    for x in rcmp_header:
        msg += chr(x)
    for x in asf_enterprise:
        msg += chr(x)
    for x in asf_msg:
        msg += chr(x)

    #for x in msg:
    #    print "0x%0.2x " % ord(x)
    print "IPMI/RMCP PING: %s" % host
    s.sendto(msg, (host, destination_port))
    resp = s.recvfrom(100)
    # print resp
    data = resp[0]
    print "Response received:"
    print "RMCP Version     : %s" % pbyte(data[0])
    print "RMCP Sequence #  : %s" % pbyte(data[2])
    iana = ord(data[3])
    #print "IANA 1 = 0x%x" % iana
    iana = (iana << 8) + ord(data[4])
    #print "IANA 2 = 0x%x" % iana
    iana = (iana << 8) + ord(data[5])
    #print "IANA 3 = 0x%x" % iana
    iana = (iana << 8) + ord(data[6])
    #print "IANA before flip = 0x%x" % iana
    iana = ntohl(iana)
    # print "IANA new = 0x%x" % iana
    print "IANA Enterprise  : 0x%x" % iana
    #print "IANA Enterprise  : 0x%x%x%x%x" % (ord(data[6]),ord(data[5]),ord(data[4]),ord(data[3]))
    oemdata = long("%x%x%x%x" % (ord(data[10]),ord(data[9]),ord(data[8]),ord(data[7])), 16)
    oemdata = ntohl(oemdata)
    # print "New OEM : 0x%x" % oemdata
    print "OEM Data         : 0x%x" % oemdata
    

if __name__ == "__main__":
    ipmi_ping(sys.argv[1])
