/*-
 * Copyright (c) 2002 Doug White
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 * 
 */

/*
 *  smic.h
 *  
 */

/* Config items */

#define SMIC_SLEEP_USECS 500

/* I/O Port ranges */
 
#define SMIC_BASE_PORT 0xca9
#define SMIC_DATA_PORT    (SMIC_BASE_PORT)
#define SMIC_CONTROL_PORT (SMIC_BASE_PORT+1)
#define SMIC_STATUS_PORT  (SMIC_BASE_PORT+1)
#define SMIC_FLAGS_PORT   (SMIC_BASE_PORT+2)

/* Flag register definitions */

#define SMIC_RX_DATA_RDY       0x80
#define SMIC_TX_DATA_RDY       0x40
#define SMIC_SMI               0x10
#define SMIC_EVT_ATN           0x08
#define SMIC_SMS_ATN           0x04
#define SMIC_BUSY              0x01

/* SMS Stream control codes */

#define SMIC_CC_SMS_GET_STATUS  0x40
#define SMIC_CC_SMS_WR_START    0x41
#define SMIC_CC_SMS_WR_NEXT     0x42
#define SMIC_CC_SMS_WR_END      0x43
#define SMIC_CC_SMS_RD_START    0x44
#define SMIC_CC_SMS_RD_NEXT     0x45
#define SMIC_CC_SMS_RD_END      0x46

/* SMS Stream status codes */

#define SMIC_SC_SMS_RDY         0xc0
#define SMIC_SC_SMS_WR_START    0xc1
#define SMIC_SC_SMS_WR_NEXT     0xc2
#define SMIC_SC_SMS_WR_END      0xc3
#define SMIC_SC_SMS_RD_START    0xc4
#define SMIC_SC_SMS_RD_NEXT     0xc5
#define SMIC_SC_SMS_RD_END      0xc6




